最短无序连续子数组+双指针

题目:

思考:

  1. 我们要找到最短连续 子数组使得这个数组有序后整个nums有序
  2. 那么意味着 除了这个要找的数组以外的nums其余部分都已经有序
  3. 要使得这个数组长度最小,就要让这个数组前和数组后的原来的 有序部分最长
  4. 将nums分为三部分(nums1,nusm2,nums3)
  5. 可以知道nums1中最大的值要比nums2最小的值小(同理nums3最小的值要比nums2最大的值大)
  6. 利用这个性质得出nusm2的左右边界
  7. 从前往后遍历:维持一个最大值max_,遇到遍历值小于max_的时候说明这个值之前存在无序部分(也就是说这个值的位置pos是nums2的潜在右边界(为什么是潜在?因为要找最右边的无序位置)这样找到最右边的无序位置和最左的无序位置作为左右边界才能使得这个数组有序后整个nums有序)
  8. 从后往前遍历:同理不赘述

实现:

cpp 复制代码
class Solution {
public:
    int findUnsortedSubarray(vector<int>& nums) {

        int l=-1;
        int r=-1;

        int max_=INT_MIN;
        int min_=INT_MAX;


        
        for (int i=0;i<nums.size();i++)
        {
            if (nums[i]<max_)
            {
                l=i;
            }
            else
            {
                max_=nums[i];
            }
        }

        for (int i=nums.size()-1;i>=0;--i)
        {
            if (nums[i]>min_)
            {
                r=i;
            }
            else
            {
                min_=nums[i];
            }
        }


        return (l!=-1)?l-r+1:0;
    }
};

合并遍历搜索:

cpp 复制代码
class Solution {
public:
    int findUnsortedSubarray(vector<int>& nums) {

        int l=-1;
        int r=-1;

        int max_=INT_MIN;
        int min_=INT_MAX;


        
        for (int i=0;i<nums.size();i++)
        {
            if (nums[i]<max_)
            {
                l=i;
            }
            else
            {
                max_=nums[i];
            }

            if (nums[nums.size()-i-1]>min_)
            {
                r=nums.size()-i-1;
            }
            else
            {
                min_=nums[nums.size()-i-1];
            }

        }

        return (l!=-1)?l-r+1:0;
    }
};
相关推荐
Nuanyt5 天前
LeetCode Hot 100 链表专题(四)· 3 题(Java)
java·算法·leetcode·链表·双指针
Nuanyt13 天前
LeetCode Hot 100 · 双指针 3 题 Java
java·笔记·算法·leetcode·双指针
Tsuki_tl14 天前
【优选算法 — 双指针】经典例题题解+算法总结
算法·蓝桥杯·力扣·刷题·双指针·1024程序员节·优选算法
2501_9339232516 天前
双指针算法:移动零+复写零(Java)
数据结构·算法·双指针
Tsuki_tl16 天前
【优选算法:双指针】——复写零题解
java·c++·算法·leetcode·数组·双指针·复写零
lvwangshu17 天前
P17723 [SCP-S 2026] 函数 / func 题解
题解·双指针·技巧·性质题·思维好题·推导题
yi0111 个月前
LeetCode 424. 替换后的最长重复字符|不定长滑动窗口:如何判断窗口是否合法?
笔记·python·算法·leetcode·双指针·滑动窗口
yi0111 个月前
LeetCode 3. 无重复字符的最长子串|不定长滑动窗口:什么时候更新最大值?
笔记·python·算法·leetcode·双指针·滑动窗口
yi0111 个月前
DAY24: LeetCode 167:两数之和 II|从暴力枚举到左右双指针
笔记·python·算法·leetcode·二分查找·双指针
yi0111 个月前
LeetCode 15:三数之和|排序 + 双指针,如何避免重复答案?
笔记·python·算法·leetcode·双指针